Signaling Maximum SID Depth (MSD) Using OSPF
Jeff Tantsura
Apstra, Inc.
jefftant.ietf@gmail.com
Uma Chunduri
Huawei Technologies
uma.chunduri@huawei.com
Sam Aldrin
Google, Inc.
aldrin.ietf@gmail.com
Peter Psenak
Cisco Systems
ppsenak@cisco.com
December 2018
BGP-LS
SID
MSD
OSPF
This document defines a way for an Open Shortest Path First (OSPF) router to advertise multiple types of supported Maximum SID Depths (MSDs) at node and/or link granularity. Such advertisements allow entities (e.g., centralized controllers) to determine whether a particular Segment Identifier (SID) stack can be supported in a given network. This document only refers to the Signaling MSD as defined in RFC 8491, but it defines an encoding that can support other MSD types. Here, the term "OSPF" means both OSPFv2 and OSPFv3.

Introduction
When Segment Routing (SR) paths are computed by a centralized controller, it is critical that the controller learn the Maximum SID Depth (MSD) that can be imposed at each node/link on a given SR path. This ensures that the Segment Identifier (SID) stack depth of a computed path doesn't exceed the number of SIDs the node is capable of imposing.
[PCEP-EXT] defines how to signal MSD in the Path Computation Element Communication Protocol (PCEP). However, if PCEP is not supported/configured on the head-end of an SR tunnel or a Binding-SID anchor node, and the controller does not participate in IGP routing, it has no way of learning the MSD of nodes and links. BGP LS (Distribution of Link-State and TE Information Using BGP) [RFC7752] defines a way to expose topology and associated attributes and capabilities of the nodes in that topology to a centralized controller. MSD signaling by BGP-LS has been defined in [MSD-BGP]. Typically, BGP-LS is configured on a small number of nodes that do not necessarily act as head-ends. In order for BGP-LS to signal MSD for all the nodes and links in the network for which MSD is relevant, MSD capabilities SHOULD be advertised by every OSPF router in the network.
Other types of MSDs are known to be useful. For example, [ELC-ISIS] defines Entropy Readable Label Depth (ERLD), which is used by a head end to insert an Entropy Label (EL) at a depth where it can be read by transit nodes.
This document defines an extension to OSPF used to advertise one or more types of MSDs at node and/or link granularity. In the future, it is expected that new MSD-Types will be defined to signal additional capabilities, e.g., ELs, SIDs that can be imposed through recirculation, or SIDs associated with another data plane such as IPv6.
MSD advertisements MAY be useful even if SR itself is not enabled. For example, in a non-SR MPLS network, MSD defines the maximum label depth.

Terminology
This memo makes use of the terms defined in [RFC7770].
BGP-LS: Distribution of Link-State and TE Information Using BGP
OSPF: Open Shortest Path First
MSD: Maximum SID Depth - the number of SIDs supported by a node or a link on a node
SID: Segment Identifier as defined in [RFC8402]
Label Imposition: Imposition is the act of modifying and/or adding labels to the outgoing label stack associated with a packet. This includes:
  - replacing the label at the top of the label stack with a new label
  - pushing one or more new labels onto the label stack
The number of labels imposed is then the sum of the number of labels that are replaced and the number of labels that are pushed. See [RFC3031] for further details.
PCEP: Path Computation Element Communication Protocol
SR: Segment Routing
LSA: Link State Advertisement
RI: Router Information

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.

Node MSD Advertisement
The Node MSD TLV within the body of the OSPF RI Opaque LSA [RFC7770] is defined to carry the provisioned SID depth of the router originating the RI LSA. Node MSD is the smallest MSD supported by the node on the set of interfaces configured for use by the advertising IGP instance. MSD values may be learned via a hardware API or may be provisioned.

Node MSD TLV

   0                   1                   2                   3
   0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  |    Type                       |  Length                       |
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  |    MSD-Type   |  MSD-Value    |  MSD-Type...  |  MSD-Value... |
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Type: 12
Length: variable (multiple of 2 octets); represents the total length of the value field in octets.
Value: consists of one or more pairs of a 1 octet MSD-Type and 1 octet MSD-Value.
MSD-Type: one of the values defined in the "IGP MSD-Types" registry defined in [RFC8491].
MSD-Value: a number in the range of 0-255. For all MSD-Types, 0 represents the lack of ability to impose an MSD stack of any depth; any other value represents that of the node. This value MUST represent the lowest value supported by any link configured for use by the advertising OSPF instance.
This TLV is optional and is applicable to both OSPFv2 and OSPFv3. The scope of the advertisement is specific to the deployment.
When multiple Node MSD TLVs are received from a given router, the receiver MUST use the first occurrence of the TLV in the Router Information (RI) LSA. If the Node MSD TLV appears in multiple RI LSAs that have different flooding scopes, the Node MSD TLV in the RI LSA with the area-scoped flooding scope MUST be used. If the Node MSD TLV appears in multiple RI LSAs that have the same flooding scope, the Node MSD TLV in the RI LSA with the numerically smallest Instance ID MUST be used and other instances of the Node MSD TLV MUST be ignored.
The RI LSA can be advertised at any of the defined opaque flooding scopes (link, area, or Autonomous System (AS)). For the purpose of Node MSD TLV advertisement, area-scoped flooding is RECOMMENDED.

Link MSD Sub-TLV
The Link MSD sub-TLV is defined to carry the MSD of the interface associated with the link. MSD values may be learned via a hardware API or may be provisioned.

Link MSD Sub-TLV

   0                   1                   2                   3
   0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  |    Type                       |  Length                       |
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  |    MSD-Type   |  MSD-Value    |  MSD-Type...  |  MSD-Value... |
  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Type:
For OSPFv2, the link-level MSD-Value is advertised as an optional sub-TLV of the OSPFv2 Extended Link TLV as defined in [RFC7684] and has a type of 6.
For OSPFv3, the link-level MSD-Value is advertised as an optional sub-TLV of the E-Router-LSA TLV as defined in [RFC8362] and has a type of 9.
Length: variable; same as defined in Section 2.
Value: consists of one or more pairs of a 1 octet MSD-Type and 1 octet MSD-Value.
MSD-Type: one of the values defined in the "IGP MSD-Types" registry defined in [RFC8491].
The MSD-Value field contains the Link MSD of the router originating the corresponding LSA as specified for OSPFv2 and OSPFv3. The Link MSD is a number in the range of 0-255. For all MSD-Types, 0 represents the lack of ability to impose an MSD stack of any depth; any other value represents that of the particular link when used as an outgoing interface.
If this sub-TLV is advertised multiple times for the same link in different OSPF Extended Link Opaque LSAs / E-Router-LSAs originated by the same OSPF router, the sub-TLV in the OSPFv2 Extended Link Opaque LSA with the smallest Opaque ID or in the OSPFv3 E-Router-LSA with the smallest Link State ID MUST be used by receiving OSPF routers. This situation SHOULD be logged as an error.

Procedures for Defining and Using Node and Link MSD Advertisements
When Link MSD is present for a given MSD-Type, the value of the Link MSD MUST take precedence over the Node MSD. When a Link MSD Type is not signaled but the Node MSD-Type is, then the Node MSD Type value MUST be considered as the MSD value for that link.
In order to increase flooding efficiency, it is RECOMMENDED that routers with homogenous Link MSD values advertise just the Node MSD value.
The meaning of the absence of both Node and Link MSD advertisements for a given MSD-Type is specific to the MSD-Type. Generally, it can only be inferred that the advertising node does not support advertisement of that MSD-Type. However, in some cases the lack of advertisement might imply that the functionality associated with the MSD-Type is not supported. Per [RFC8491], the correct interpretation MUST be specified when an MSD-Type is defined.

IANA Considerations
This specification updates several existing OSPF registries.
IANA has allocated TLV type 12 from the "OSPF Router Information (RI) TLVs" registry as defined by [RFC7770].

RI Node MSD

   Value     Description                      Reference
   -----     ---------------                  -------------
   12        Node MSD                         This document

IANA has allocated sub-TLV type 6 from the "OSPFv2 Extended Link TLV Sub-TLVs" registry.

OSPFv2 Link MSD

   Value     Description                      Reference
   -----     ---------------                  -------------
   6         OSPFv2 Link MSD                  This document

IANA has allocated sub-TLV type 9 from the "OSPFv3 Extended-LSA Sub TLVs" registry.

OSPFv3 Link MSD

   Value     Description                      Reference
   -----     ---------------                  -------------
   9         OSPFv3 Link MSD                  This document

Security Considerations
Security concerns for OSPF are addressed in [RFC7474], [RFC4552], and [RFC7166]. Further security analysis for the OSPF protocol is done in [RFC6863]. Security considerations as specified by [RFC7770], [RFC7684], and [RFC8362] are applicable to this document.
Implementations MUST ensure that malformed TLVs and sub-TLVs defined in this document are detected and do not provide a vulnerability for attackers to crash the OSPF router or routing process. Reception of malformed TLVs or sub-TLVs SHOULD be counted and/or logged for further analysis. Logging of malformed TLVs and sub-TLVs SHOULD be rate limited to prevent a Denial-of-Service (DoS) attack (distributed or otherwise) from overloading the OSPF control plane.
Advertisement of an incorrect MSD value may have negative consequences. If the value is smaller than supported, path computation may fail to compute a viable path. If the value is larger than supported, an attempt to instantiate a path that can't be supported by the head-end (the node performing the SID imposition) may occur.
The presence of this information may also inform an attacker of how to induce any of the aforementioned conditions.
There's no DoS risk specific to this extension, and it is not vulnerable to replay attacks.

Normative References

Informative References
[PCEP-EXT]

PCEP Extensions for Segment Routing
Siva Sivabalan
Clarence Filsfils
Jeff Tantsura
Wim Henderickx
Jonathan Hardwick
October 2018
Work in Progress, draft-ietf-pce-segment-routing-14
[MSD-BGP]

Signaling MSD (Maximum SID Depth) using Border Gateway Protocol Link-State
Jeff Tantsura
Uma Chunduri
Gregory Mirsky
Siva Sivabalan
August 2018
Work in Progress, draft-ietf-idr-bgp-ls-segment-routing-msd-02
[ELC-ISIS]

Signaling Entropy Label Capability and Entropy Readable Label-stack Depth Using OSPF
Xiaohu Xu
Sriganesh Kini
Siva Sivabalan
Clarence Filsfils
Stephane Litkowski
September 2018
Work in Progress, draft-ietf-ospf-mpls-elc-07
[RFC7752]
[RFC7770]
[RFC8402]
[RFC3031]
[RFC2119]
[RFC8174]
[RFC8491]
[RFC7684]
[RFC8362]
[RFC7474]
[RFC4552]
[RFC7166]
[RFC6863]

Acknowledgements
The authors would like to thank Acee Lindem, Ketan Talaulikar, Tal Mizrahi, Stephane Litkowski, and Bruno Decraene for their reviews and valuable comments.

Contributors
The following person contributed to this document:
Les Ginsberg
Email: ginsberg@cisco.com